package grafika;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.GridLayout;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.text.AbstractDocument.Content;



public class Igrica extends JFrame {

	
	private  KnightFightEngine engine;
	
	private JPanel glavniPanel;
	private JPanel gornjiPanel;
	private JPanel panelBrojPoteza;
	private JPanel panelNaPotezu;
	private JPanel donjiPanel;
	
	private JLabel textBrojPoteza;
	private JLabel intBrojPoteza;
	private JLabel labelNaPotezu;
	
	private JButton nova;
	
	private int brojPoteza;
	
	
	
	
	
	public Igrica() {
		super("Borba skakaca");
		// TODO Auto-generated constructor stub
		
		inicijalizuj();
		grafika();
	}

	/**
	 * inicijalizujemo atribute ....
	 * 
	 */
	private void inicijalizuj()
	{
		engine = new KnightFightEngine();
		brojPoteza = 0;
		
		// gornji panel
		gornjiPanel = new JPanel(new GridLayout(0, 2));
		panelBrojPoteza = new JPanel(new FlowLayout(FlowLayout.LEFT));
		panelNaPotezu = new JPanel(new FlowLayout(FlowLayout.RIGHT));
		donjiPanel = new JPanel(new FlowLayout(FlowLayout.CENTER));
		
		textBrojPoteza = new JLabel("Poteza:");
		intBrojPoteza = new JLabel(" " + brojPoteza);
		
		labelNaPotezu = new JLabel("Na potezu ");
		nova = new JButton("Nova");
		
		// glavni panel
		glavniPanel = new JPanel(new GridLayout(8, 8, 5, 5));
					
	}
	
	/**
	 * crtamo grafiku ...
	 * 
	 */
	private void grafika()
	{
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		
		// objekat  glavnog panela
		Container c = getContentPane();
		
		// borderlayout
		c.setLayout(new BorderLayout());
		
		// dimenzije prozora
		Toolkit toolkit = c.getToolkit();
		Dimension dim = toolkit.getScreenSize();
		setBounds(dim.width/4, dim.height/4, dim.width/2, dim.height/2);
		
		// gornji panel
		gornjiPanel();
		// glavni panel
		glavniPanel();
		donjiPanel();
		setVisible(true);
	}
	
	private void donjiPanel() 
	{
		nova.addActionListener(new ActionListener() {
			
			@Override
			public void actionPerformed(ActionEvent arg0) {
				int op=JOptionPane.showConfirmDialog(null, "Da li ste sigurni da to zelite?","Borba skakaca",
						JOptionPane.YES_NO_OPTION,JOptionPane.QUESTION_MESSAGE);
			
			}
		});
		
		gornjiPanel.setOpaque(true);
		donjiPanel.add(nova);
		getContentPane().add(donjiPanel, BorderLayout.SOUTH);
	}

	private void gornjiPanel()
	{
		// gornji panel u kom su labale...
		gornjiPanel.setOpaque(true);
						
		panelBrojPoteza.setOpaque(true);
		panelBrojPoteza.add(textBrojPoteza);
		panelBrojPoteza.add(intBrojPoteza);
		gornjiPanel.add(panelBrojPoteza);
		
		panelNaPotezu.setOpaque(true);
		panelNaPotezu.add(labelNaPotezu);
		gornjiPanel.add(panelNaPotezu);
		
		getContentPane().add(gornjiPanel, BorderLayout.NORTH);
	}
	
	private void glavniPanel()
	{
		for (int x=0;x<8;x++)
		{
			for(int y=0;y<8;y++)
			{
				glavniPanel.add(engine.getFigure(x,y));
			}
		}
		getContentPane().add(glavniPanel, BorderLayout.CENTER);
	}
	

}
