import java.util.Random;

public class KnightFightEngine {
	
	
	private int igra, beliPotezi, crniPotezi;
	private Figure[][] tabla;
	private int brKlikova, odI, odJ, doI, doJ;
	private Figure figura;

	
	public Figure getFigure(int i, int j) {
		return tabla[i][j];
	}
	
	public KnightFightEngine() {
		initialize();
	}
	
	public void initialize() {
		igra = 1;
		beliPotezi = 0;
		crniPotezi= 0;
		brKlikova = 0;
		
		Figure fig;
		tabla = new Figure[8][8];
		
		for(int i = 0; i < 8; i++)
			for(int j = 0; j < 8; j++)
				tabla[i][j] = null;
		
		for(int i = 0; i < 3; i++){
			fig = new Skakac("Bela");
			deployFigure(0, fig);
		}
		
		fig = new Kralj("Bela");
		deployFigure(0, fig);
		
		
		for(int j = 0; j < 3; j++){
			fig = new Skakac("Crna");
			deployFigure(7, fig);
		}
		
		fig = new Kralj("Crna");
		deployFigure(7, fig);
	}
	
	public Figure[] getFigures(){
		Figure[] fs = new Figure[8];
		int br = 0;
		for(int i = 0; i < 8; i++)
			for(int j = 0; j < 8; j++){
				if(tabla[i][j] != null)
					fs[br++] = tabla[i][j];
			}
		
		Figure[] figs = new Figure[br];
		for(int i = 0; i < br; i++)
			figs[i] = fs[i];
		return figs; 
	}
	
	
	// Postavlja figuru na slobodno nasumicno polje u i-tom redu
	private void deployFigure(int i, Figure figure) {
		Random rnd = new Random();
		int k = rnd.nextInt(8);
		while (tabla[i][k] != null){
			k = rnd.nextInt(8);
		}
		figure.setI(i);
		figure.setJ(k);
		tabla[i][k] = figure;
	}
	
	
	public boolean klik(int i, int j){
		if (brKlikova == 0 && tabla[i][j] != null){
			odI = i; odJ = j;
			brKlikova++;
			System.out.println("prvi klik");
			return false;

		}
		else if(brKlikova == 1 && tabla[odI][odJ].isOK(i, j)){
			if((tabla[i][j] != null && tabla[i][j].getBoja() != igra) || tabla[i][j] == null){
					System.out.println("trenutno igra "+igra);
					brKlikova = 0;
					igra = (igra % 2) + 1;
					doI = i;
					doJ = j;
					move(odI, odJ, doI, doJ);
					return true;
				}
				
		}
		return false;
			
	}
	
	
	
	public void move(int odI, int odJ,int doI,int doJ){
		tabla[doI][doJ] = tabla[odI][odJ];
		tabla[doI][doJ].i = doI;
		tabla[doI][doJ].j = doJ;
		tabla[odI][odJ] = null;
		
	}
	
	
/*
	public boolean move(int fromI, int fromJ, int toI, int toJ) {
		for(int i = 0; i < 8; i++){
			for(int j = 0; j < 8; j++){
				bs[i][j].postaviBoju();
			}
		
	}
	
	public boolean isEnd() {
		
	}
	
	public String getWinner() {
		
	}
*/
	public String getActivePlayer(){
		if(igra == 1){
			return "BELI";
		}
		else if(igra == 2){
			return "CRNI";
		}
		else return null;
	}
	
	public int getMoveCount(){
		if(igra == 1){
			return beliPotezi;
		}
		else if(igra ==2){
			return crniPotezi;
		}
		else return -1;
	}
}

