import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.GridBagConstraints;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.border.Border;
import javax.swing.text.StyledEditorKit.BoldAction;


public class GUI {
	Engine igra=new Engine();
	JButton b3=new JButton("Nova");
	JLabel l1=new JLabel("Broj Poteza: 0");
	JLabel l2=new JLabel("Na potezu beli igrac");
	JFrame prozor=new JFrame("Borba skakaca");
	JButton dugmici[][]=new JButton[8][8];
	Color pozadina[]={Color.white,Color.gray};
	ImageIcon SB=new ImageIcon("S[Bela].png");
	ImageIcon SC=new ImageIcon("S[Crna].png");
	ImageIcon KB=new ImageIcon("K[Bela].png");
	ImageIcon KC=new ImageIcon("K[Crna].png");
	int i1,j1,i2,j2;
	boolean prvi=true;
	boolean drugi=false;
	
	
	public GUI(){
		setWindows();
		setPanel1();
		setPanel2();
		setPanel3();
	}
	
	public void setWindows(){
		prozor.setVisible(true);
		prozor.setBounds(100, 100, 600, 600);
		prozor.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		prozor.setLayout(new BorderLayout());
		
	}
	
	public void setPanel1(){
		JPanel p1=new JPanel();
		p1.setLayout(new FlowLayout());
		p1.add(l1);
		p1.add(l2);
		prozor.add(p1,BorderLayout.NORTH);
	}
	
	public void setPanel2(){
		
		JPanel p2=new JPanel();
		p2.setLayout(new GridLayout(8, 8, 5, 5));
	
		for(int i=0;i<8;i++)
			for(int j=0;j<8;j++){
				dugmici[i][j]=new JButton();
				dugmici[i][j].setPreferredSize(new Dimension(5,5));
				dugmici[i][j].setBackground(pozadina[(i+j)%2]);
				if(igra.matrica[i][j]==1) dugmici[i][j].setIcon(SB);
				if(igra.matrica[i][j]==2) dugmici[i][j].setIcon(KB);
				if(igra.matrica[i][j]==-1) dugmici[i][j].setIcon(SC);
				if(igra.matrica[i][j]==-2) dugmici[i][j].setIcon(KC);
				
				
				dugmici[i][j].addActionListener(new ActionListener() {
					
					@Override
					public void actionPerformed(ActionEvent e) {
						// TODO Auto-generated method stub
						
						for(int i=0;i<8;i++)
							for(int j=0;j<8;j++)
								if(e.getSource()==dugmici[i][j]){
									if(prvi){
										i1=i;
										j1=j;
										prvi=false;
										drugi=true;
									}
									else{
										i2=i;
										j2=j;
										prvi=true;
										drugi=false;

										if(igra.pojeo(i1, j1, i2, j2)==0){
											if (igra.tekuci==1) igra.PotezB++;
											else igra.PotezC++;
											dugmici[i1][j1].setIcon(null);
											if(igra.matrica[i1][j1]==1)
												dugmici[i2][j2].setIcon(SB);
											else if(igra.matrica[i1][j1]==2)
												dugmici[i2][j2].setIcon(KB);
											else if(igra.matrica[i1][j1]==-1)
												dugmici[i2][j2].setIcon(SC);
											else if(igra.matrica[i1][j1]==-2)
												dugmici[i2][j2].setIcon(KC);
											igra.matrica[i2][j2]=igra.matrica[i1][j1];
											igra.matrica[i1][j1]=0;
											
											igra.zameni();
											if(igra.tekuci==1){
												l1.setText("Broj Pokusaja: "+igra.PotezB);
												l2.setText("Na potezu je BELI igrac");
											}
											else{
												l1.setText("Broj Pokusaja: "+igra.PotezB);
												l2.setText("Na potezu je CRNI igrac");
												
											}
											
										}
										if(igra.pojeo(i1, j1, i2, j2)==-1){
											int s=JOptionPane.showConfirmDialog(null,"Pobedio je BELI igrac\n Nova Igra?","Borba Skakaca",JOptionPane.YES_NO_OPTION,JOptionPane.QUESTION_MESSAGE);
											if(s== JOptionPane.OK_OPTION){
												igra.nova();
												nova();
											}
										}
										if(igra.pojeo(i1, j1, i2, j2)==1){
											int s=JOptionPane.showConfirmDialog(null,"Pobedio je CRNI igrac\n Nova Igra?","Borba Skakaca",JOptionPane.YES_NO_OPTION,JOptionPane.QUESTION_MESSAGE);
											if(s== JOptionPane.OK_OPTION){
												igra.nova();
												nova();
											}
										}
									}
								}
					}
				});
				
				
				p2.add(dugmici[i][j]);
			}
		prozor.add(p2,BorderLayout.CENTER);
	}
	
	public void setPanel3(){
		JPanel p3=new JPanel();
		p3.setLayout(new FlowLayout());
		p3.add(b3);
		b3.addActionListener(new ActionListener() {
			
			@Override
			public void actionPerformed(ActionEvent arg0) {
				// TODO Auto-generated method stub
				igra.nova();
				nova();
				
				
			}
		});
		prozor.add(p3,BorderLayout.SOUTH);
		
	}
	
	
	
	
	
	public void nova(){
		for(int i=0;i<8;i++)
			for(int j=0;j<8;j++){
				
				dugmici[i][j].setPreferredSize(new Dimension(5,5));
				dugmici[i][j].setBackground(pozadina[(i+j)%2]);
				dugmici[i][j].setIcon(null);
				if(igra.matrica[i][j]==1) dugmici[i][j].setIcon(SB);
				if(igra.matrica[i][j]==2) dugmici[i][j].setIcon(KB);
				if(igra.matrica[i][j]==-1) dugmici[i][j].setIcon(SC);
				if(igra.matrica[i][j]==-2) dugmici[i][j].setIcon(KC);
				prvi=true;
				drugi=false;
				l1.setText("Broj Poteza: 0");
				l2.setText("Na potezu beli igrac");
			}
		
		
		
	}
	
	
	
	
	
}
