import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;


public class GUI extends JFrame {
	
	public JLabel potezi=new JLabel("Broj Poteza: 0                                           ");
	public JLabel naredu=new JLabel("Na potezu BELI igrac");
	public Container cp;
	Polje tabla[][];
	JButton nova;
	KnightFightEngine engine;
	int dragged=0;
	int naPotezu=0;
	Figure vuce;
	int brPoteza=0;
	int prei;
	int prej;
	
	public GUI(){
		setBounds(100, 100, 500, 530);
		setVisible(true);
		setDefaultCloseOperation(EXIT_ON_CLOSE);
		cp = getContentPane();
		addNorth();
		tabla=new Polje[8][8];
		for(int i = 0; i < 8; i++)
			for(int j=0; j<8; j++){
				tabla[i][j]=new Polje(i,j);
				tabla[i][j].addActionListener(new MyListener());
				if((i+j)%2==1) tabla[i][j].setBackground(new Color(100,100,100));
			}
		addCenter();
		addSouth();
		
		engine = new KnightFightEngine();
		Figure x = null;
		for(int i = 0; i < 8; i++)
			for(int j=0; j<8; j++){
				x=engine.getFigure(i, j);
				if(x!=null){
					if(x instanceof King && x.boja=="white")
						tabla[i][j].setIcon( new ImageIcon("K[Bela].png"));
					if(x instanceof King && x.boja=="black")
						tabla[i][j].setIcon( new ImageIcon("K[Crna].png"));
					
					if(x instanceof Horse && x.boja=="white")
						tabla[i][j].setIcon( new ImageIcon("S[Bela].png"));
					if(x instanceof Horse && x.boja=="black")
						tabla[i][j].setIcon( new ImageIcon("S[Crna].png"));
				}
			}
		nova.addActionListener(new NewListener());
	}
	
	
	void addNorth(){
		JPanel top = new JPanel();
		//top.setLayout(new FlowLayout());
		top.add(potezi,FlowLayout.LEFT);
		top.add(naredu);
		cp.add(top,BorderLayout.NORTH);
	}
	
	void addCenter(){
		JPanel centar = new JPanel();
		centar.setLayout(new GridLayout(8,8));
		
		for(int i = 0; i < 8; i++)
			for(int j=0; j<8; j++){
				centar.add(tabla[i][j]);
			}
		cp.add(centar,BorderLayout.CENTER);
	}
	
	void addSouth(){
		nova=new JButton("Nova");
		JPanel x = new JPanel();
		x.add(nova);
		cp.add(x,BorderLayout.SOUTH);
	}
	
	
	class MyListener implements ActionListener{

		
		public void actionPerformed(ActionEvent e) {
			Polje x =(Polje) e.getSource();
			
			if(dragged==0) {
				dragged=1;
				/*vuce=null;*/
				prei=x.i;
				prej=x.j;
			}
			else dragged=0;
			
			if(dragged==1){
				x.setBackground(Color.CYAN);
				vuce=engine.getFigure(x.i, x.j);
				System.out.println(vuce);
				
			}
			
			if(dragged==0){
				brPoteza++;
				potezi.setText("Broj Poteza: " +brPoteza/2+"                                           ");
				if(brPoteza%2==0){
					naredu.setText("Na potezu BELI igrac");
				}
				else naredu.setText("Na potezu CRNI igrac");
				if(vuce.move(vuce.i,vuce.j,x.i,x.j)){
					tabla[vuce.i][vuce.j].setIcon(null);
					engine.move(vuce.i, vuce.j, x.i, x.j);
					if((prei+prej)%2==1)
						tabla[prei][prej].setBackground(Color.GRAY);
					else
						tabla[prei][prej].setBackground(Color.WHITE);
					
					
					//if(vuce!=null){
						if(vuce instanceof King && vuce.boja=="white")
							tabla[x.i][x.j].setIcon( new ImageIcon("K[Bela].png"));
						if(vuce instanceof King && vuce.boja=="black")
							tabla[x.i][x.j].setIcon( new ImageIcon("K[Crna].png"));
						
						if(vuce instanceof Horse && vuce.boja=="white")
							tabla[x.i][x.j].setIcon( new ImageIcon("S[Bela].png"));
						if(vuce instanceof Horse && vuce.boja=="black")
							tabla[x.i][x.j].setIcon( new ImageIcon("S[Crna].png"));
				//	}
					
				}
			}
			
			
		}
		
	}
	
	class NewListener implements ActionListener {

		
		public void actionPerformed(ActionEvent e) {
			
			engine=new KnightFightEngine();
			int dragged=0;
			int naPotezu=0;
			Figure vuce;
			int brPoteza=0;
			Figure x = null;
			engine.initialize();
			
			
			
			for(int i = 0; i < 8; i++)
				for(int j=0; j<8; j++){
					x=engine.getFigure(i, j);
					if(x!=null){
						if(x instanceof King && x.boja=="white")
							tabla[i][j].setIcon( new ImageIcon("K[Bela].png"));
						if(x instanceof King && x.boja=="black")
							tabla[i][j].setIcon( new ImageIcon("K[Crna].png"));
						
						if(x instanceof Horse && x.boja=="white")
							tabla[i][j].setIcon( new ImageIcon("S[Bela].png"));
						if(x instanceof Horse && x.boja=="black")
							tabla[i][j].setIcon( new ImageIcon("S[Crna].png"));
						
					}
					if(x==null)
						tabla[i][j].setIcon(null);
				}
			
		}
		
		
	}
	
}

class Polje extends JButton{
	
	//Figure fig = null;
	int i,j;
	
	public Polje(int x,int y){
		i=x;j=y;
		setSize(60,60);
		setBackground(Color.WHITE);
		setPreferredSize(new Dimension(60,60));
		//setBorder(new LineBorder(Color.BLACK,1));
		/*
		if(fig!=null){
			this.setIcon(new ImageIcon("K[bela].png"));
		}
		*/
	}
	
}