package borba.skakaca;

import java.awt.Color;
import java.util.Random;

import javax.swing.border.LineBorder;

public class Engine {
	
	private Random r;
	private Polje polje;
	boolean izabrano;
	private Kralj beliKralj;
	private Kralj crniKralj;
	private Skakac[] beliSkakac = new Skakac[3];
	private Skakac[] crniSkakac = new Skakac[3];
	boolean beliNaPotezu;
	private int brojPotezaBeli;
	private int brojPotezaCrni;
	private Color boja = Color.decode("0x46d1ef");
	
	public Engine() {
		r = new Random();
		beliKralj = new Kralj("K[Bela].png",true);
		crniKralj = new Kralj("K[Crna].png",false);
		for(int i=0;i<3;i++){
			beliSkakac[i] = new Skakac("S[Bela].png",true);
			crniSkakac[i] = new Skakac("S[Crna].png",false);
		}
		restart();
	}
	
	public void restart(){
		beliNaPotezu = true;
		brojPotezaBeli=0;
		brojPotezaCrni=0;
		izabrano = false;
	}
	
	public void setBeli(Polje[] p){
		boolean[] used = new boolean[8];
		for(int i=0; i<8;i++)
			used[i] = false;
		//postavlja skakace
		for(int s=0; s<beliSkakac.length; s++){
			int i;
			do{
				i = r.nextInt(8);
			}while(used[i]==true);
			used[i] = true;
			p[i].setFigure(beliSkakac[s]);
		}
		
		//postavlja kralja
		int i;
		do{
			i = r.nextInt(8);
		}while(used[i]==true);
		p[i].setFigure(beliKralj);
	}
	
	public void setCrni(Polje[] p){
		boolean[] used = new boolean[8];
		for(int i=0; i<8;i++)
			used[i] = false;
		//postavlja skakace
		for(int s=0; s<crniSkakac.length; s++){
			int i;
			do{
				i = r.nextInt(8);
			}while(used[i]==true);
			used[i] = true;
			p[i].setFigure(crniSkakac[s]);
		}
		
		//postavlja kralja
		int i;
		do{
			i = r.nextInt(8);
		}while(used[i]==true);
		p[i].setFigure(crniKralj);
	}
	
	public void click(Polje p)throws Exception{
		Figure f2 = p.getFigura();
		if(izabrano && f2==null){//da li je vec izabrao a nije opet kliknuo na figuru
			Figure f1 = polje.getFigura();
			
			if(f1.skoci(polje.getI(), polje.getJ(), p.getI(), p.getJ()) && !f1.isti(f2)){
				polje.setFigure(null);
				p.setFigure(f1);
				izabrano = false;
				if(beliNaPotezu){
					if(f2 == crniKralj) throw new Exception();
					beliNaPotezu = false;
					brojPotezaBeli++;
				}
				else{
					if(f2 == beliKralj) throw new Exception();
					beliNaPotezu = true;
					brojPotezaCrni++;
				}
				polje.setBorder(new LineBorder(Color.black,1));
			}
		}
		else{
			if(f2!=null)// ako ima figuru
				if(f2.boja(beliNaPotezu)){
					p.setBorder(new LineBorder(boja,3));
					if(polje!=null) polje.setBorder(new LineBorder(Color.black,1));
					polje = p;
					izabrano = true;
				}
		}
		
	}
	
	public boolean jeBeli() {
		return beliNaPotezu;
	}
	
	public int getBrojPoteza() {
		if(beliNaPotezu) return brojPotezaBeli;
		else return brojPotezaCrni;
	}
	
}
