package borba.skakaca;

import java.awt.BorderLayout;
import java.awt.Cursor;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;

public class GUI extends JFrame implements ActionListener{
	
	private JLabel potez;
	private JLabel igrac;
	private Polje[][] p;
	private Engine engine;
	
	public GUI() {
		engine = new Engine();
		setBounds(50, 50, 500, 550);
		setResizable(false);
		setTitle("Borba skakaca");
		setVisible(true);
		setLayout(new BorderLayout());
		setDefaultCloseOperation(EXIT_ON_CLOSE);
		sever();
		centar();
		jug();
		engine.setBeli(p[0]);
		engine.setCrni(p[7]);
		setCursor(Cursor.HAND_CURSOR);
	}
	
	private void sever(){
		JPanel sever = new JPanel(new GridLayout(1,2));
		add(sever,BorderLayout.NORTH);
		
		potez = new JLabel("Potez: 0");
		sever.add(potez);
		igrac = new JLabel("Na potezu je BELI");
		sever.add(igrac);
	}
	
	private void jug(){
		JPanel jug = new JPanel();
		add(jug, BorderLayout.SOUTH);
		JButton nova = new JButton("Nova");
		nova.addActionListener(new ActionListener() {
			
			@Override
			public void actionPerformed(ActionEvent arg0) {
				restart();
			}
		});
		jug.add(nova);
	}
	
	private void centar(){
		JPanel centar = new JPanel(new GridLayout(8,8,0,0));
		add(centar, BorderLayout.CENTER);
		centar.setBorder(BorderFactory.createEmptyBorder(5,5,5,5));
		p = new Polje[8][8];
		for(int i=0;i<8;i++)
			for(int j=0;j<8;j++)
			{
				p[i][j] = new Polje(i, j);
				p[i][j].addActionListener(this);
				centar.add(p[i][j]);
			}
	}

	
	
	private void restart(){
		for(int i=0;i<8;i++)
			for(int j=0;j<8;j++)
				p[i][j].setFigure(null);
		engine.setBeli(p[0]);
		engine.setCrni(p[7]);
		engine.restart();
		potez.setText("Potez: 0");
		igrac.setText("Na potezu je BELI");
	}
	@Override
	public void actionPerformed(ActionEvent e) {
		Polje p = (Polje) e.getSource();
		try {
			engine.click(p);
		} catch (Exception e1) {
			String poruka;
			if(engine.beliNaPotezu) 
				poruka = "Pobedio je BELI u "+(engine.getBrojPoteza()+1) +" poteza";
			else
				poruka = "Pobedio je BELI u "+(engine.getBrojPoteza()+1) +" poteza";
			int i = JOptionPane.showConfirmDialog(null, poruka,"Kraj",JOptionPane.OK_CANCEL_OPTION,JOptionPane.QUESTION_MESSAGE);
			if(i==JOptionPane.OK_OPTION) restart();
			else System.exit(0);
		}
		if(engine.beliNaPotezu) igrac.setText("Na potezu je BELI");
		else igrac.setText("Na potezu je CRNI");
		potez.setText("Potez: "+engine.getBrojPoteza());
	}
	
}
