package sah;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.ImageIcon;
import javax.swing.JPanel;
import javax.swing.border.LineBorder;

public class Tabla extends JPanel{
	private Dugme[][] dugmad;
	private Dugme izabrano=null;
	
	public Tabla(){
		postaviDugmad();
		//postaviFigure();
	}
	
	private void postaviDugmad(){
		this.setLayout(new GridLayout(8,8));
		dugmad = new Dugme[8][8];
		int boja=0;
		Osluskivac osluskivac = new Osluskivac();
		for(int i=0;i<8;i++){
			boja=(i%2);
			for( int j=0;j<8;j++){
				dugmad[i][j] = new Dugme(i,j);
			//	dugmad[i][j].setPreferredSize(new Dimension(40,40));
			//	dugmad[i][j].setBorder(new LineBorder(Color.DARK_GRAY,1));
				if(boja%2==0) dugmad[i][j].setBackground(Color.WHITE);
				else dugmad[i][j].setBackground(Color.GRAY);
				boja++;
			//	dugmad[i][j].addActionListener(osluskivac);
				this.add(dugmad[i][j]);
			}
		}
	}
	
	private class Osluskivac implements ActionListener{
		public void actionPerformed(ActionEvent ae){
			Dugme dugme = (Dugme)ae.getSource();
			izabrano=dugme;
			dalje();
		}
	}
	
	
	
	public synchronized Dugme getIzabrano(){
		while(izabrano==null)
			try {wait();} catch (InterruptedException e) {e.printStackTrace();}
		Dugme dugme = izabrano;
		izabrano=null;
		return dugme;
	}
	
	public synchronized void dalje(){
		notify();
	}
	
	public void postaviFigure(){
		boolean maska[][] = new boolean[8][8];
		for(int i=0;i<8;i++)
			for(int j=0;j<8;j++)
				maska[i][j]=false;
		ImageIcon beliSkakac = new ImageIcon("S[Bela].png");
		ImageIcon crniSkakac = new ImageIcon("S[Crna].png");
		ImageIcon beliKralj = new ImageIcon("K[Bela].png");
		ImageIcon crniKralj = new ImageIcon("K[Crna].png");
		
		ocistiTablu();
		
		int p;
		int q;
		for(int i=0;i<3;i++){
			do{
				p=(int)(Math.random()*8);
				q=(int)(Math.random()*8);
			}while(p==q || maska[p][q]==true);
			maska[p][q] = true;
			Figura figura = new Skakac(beliSkakac,0);
			dugmad[p][q].setFigura(figura);
		}
		for(int i=0;i<3;i++){
			do{
				p=(int)(Math.random()*8);
				q=(int)(Math.random()*8);
			}while(p==q || maska[p][q]==true);
			maska[p][q] = true;
			Figura figura = new Skakac(crniSkakac,1);
			dugmad[p][q].setFigura(figura);
		}
		
		do{
			p=(int)(Math.random()*8);
			q=(int)(Math.random()*8);
		}while(p==q || maska[p][q]==true);
		
		Figura f = new Kralj(beliKralj,0);
		Figura ff = new Kralj(crniKralj,1);
		
		dugmad[p][q].setFigura(f);
		
		do{
			p=(int)(Math.random()*8);
			q=(int)(Math.random()*8);
		}while(p==q || maska[p][q]==true);
		dugmad[p][q].setFigura(ff);
		
		for(int i=0;i<8;i++)
			for(int j=0;j<8;j++)
				dugmad[i][j].otkrijSe();
		
	}
	
	private void ocistiTablu(){
		for(int i=0;i<8;i++)
			for(int j=0;j<8;j++)
				dugmad[i][j].setFigura(null);
	}
	
	public void skloni(int i, int j){
		dugmad[i][j].setIcon(null);
		dugmad[i][j].otkrijSe();
	}
	
	
	

}
